# Change Proposals

This document is intended to keep a record of suggested changes to UEAPI. It is a living document and will be updated as new proposals are made. New proposals should be added to the top of the document.

## 2024-03-04
### Proposal: Implement versioning for UEAPI
#### Summary
The current UEAPI is not versioned. This makes it difficult to make changes to the API without breaking existing clients. We should implement versioning for UEAPI to make it easier to make changes to the API without breaking existing clients.

### Proposal: Introduce soft deprecation for UEAPI events
#### Summary
Until versioning is implemented, we may want to make some non-breaking changes to consolidate and/or simplify events until we can delete any lingering events or event fields that have been deprecated.
One such proposal is to consolidate display and audio/video ads events. We could create a deprecation document similar to the one for [deprecated event fields](./deprecated_event_fields.md) and mark the events as soft-deprecated with a comment. Below is the proposal for consolidation:

##### New events
- `ads_requested`
- `ads_request_failed`
- `ads_response_received`
- `ads_impression`

##### Soft-deprecated events:
- `ads_display_requested`
- `ads_display_request_failed`
- `ads_display_response_received`
- `ads_display_impression`
- `ads_video_audio_roll_requested`
- `ads_video_audio_roll_request_failed`
- `ads_video_audio_roll_response_received`
- `ads_video_audio_roll_impression`
