
## Discord Activity Events Topology

### Events Flow chart

```mermaid
flowchart TD
    A[App is Launched by the User] --> |Accepts oauth| DiscordOauthAcceptedEvent{{DiscordOauthAcceptedEvent}}
    A[App is Launched by the User] --> |Denies oauth| DiscordOauthDeniedEvent{{DiscordOauthDeniedEvent}}
    style DiscordOauthDeniedEvent fill: #5A3A40
    style DiscordOauthAcceptedEvent fill: #3A5A40
    DiscordOauthAcceptedEvent --> |Initialize activity| DiscordActivityInitiatedEvent{{DiscordActivityInitiatedEvent}}
    DiscordOauthAcceptedEvent --> |Max participants reached| DiscordMaxParticipantsReachedEvent{{DiscordMaxParticipantsReachedEvent}}
    style DiscordMaxParticipantsReachedEvent fill: #5A3A40
    DiscordActivityInitiatedEvent --> |User joins| DiscordUserJoinedEvent{{DiscordUserJoinedEvent}}
    DiscordUserJoinedEvent --> |First user / Host asigns new host| DiscordHostAssignedEvent{{DiscordHostAssignedEvent}}
    DiscordUserJoinedEvent --> |Host enables shared mode| DiscordSharedModeActivatedEvent{{DiscordSharedModeActivatedEvent}}
    DiscordUserJoinedEvent --> |Host disables shared mode| DiscordSharedModeDeactivatedEvent{{DiscordSharedModeDeactivatedEvent}}
    DiscordUserJoinedEvent --> |User leaves| DiscordUserLeftEvent{{DiscordUserLeftEvent}}
    DiscordUserJoinedEvent --> |Host ends activity| DiscordActivityEndedEvent{{DiscordActivityEndedEvent}}
    DiscordHostAssignedEvent
    DiscordSharedModeActivatedEvent
    DiscordSharedModeDeactivatedEvent
    DiscordActivityEndedEvent
```



NOTE: to display charts please install [Chrome Extension](https://chrome.google.com/webstore/detail/mermaid-diagrams/)
NOTE: to edit charts please use [Online editor](https://mermaid.live/) and [Documentation](https://mermaid.js.org/)


### Events Details and Schemas
| Events                              | [EventType](./common/v1/event_type.proto)  | [EventCode](./common/v1/event_code.proto) | Protobuf Schema                                                                                      |   |
|-------------------------------------|---|-------------------------------------------|------------------------------------------------------------------------------------------------------|---|
| `DiscordActivityInitiatedEvent`     |  `EVENT_TYPE_TRACK` | `DISCORD_ACTIVITY_INITIATED`              | [discord_activity_initiated.proto](./events/discord/v1/discord_activity_initiated.proto)             |   |
| `DiscordActivityEndedEvent`         |  `EVENT_TYPE_TRACK` | `DISCORD_ACTIVITY_ENDED`                  | [discord_activity_ended.proto](./events/discord/v1/discord_activity_ended.proto)                     |   |
| `DiscordHostAssignedEvent`          |  `EVENT_TYPE_TRACK` | `DISCORD_HOST_ASSIGNED`                   | [discord_host_assigned.proto](./events/discord/v1/discord_host_assigned.proto)                       |   |
| `DiscordSharedModeActivatedEvent`   |  `EVENT_TYPE_TRACK` | `DISCORD_SHARED_MODE_ACTIVATED`           | [discord_shared_mode_activated.proto](./events/discord/v1/discord_shared_mode_activated.proto)       |   |
| `DiscordSharedModeDeactivatedEvent` |  `EVENT_TYPE_TRACK` | `DISCORD_SHARED_MODE_DEACTIVATED`         | [discord_shared_mode_deactivated.proto](./events/discord/v1/discord_shared_mode_deactivated.proto)   |   |
| `DiscordUserJoinedEvent`            |  `EVENT_TYPE_TRACK` | `DISCORD_USER_JOINED`                     | [discord_user_joined.proto](./events/discord/v1/discord_user_joined.proto)                           |   |
| `DiscordUserLeftEvent`              |  `EVENT_TYPE_TRACK` | `DISCORD_USER_LEFT`                       | [discord_user_left.proto](./events/discord/v1/discord_user_left.proto)                               |   |
| `DiscordOauthAcceptedEvent`         |  `EVENT_TYPE_TRACK` | `DISCORD_OAUTH_ACCEPTED`                  | [discord_oauth_accepted.proto](./events/discord/v1/discord_oauth_accepted.proto)                     |   |
| `DiscordOauthDeniedEvent`           |  `EVENT_TYPE_TRACK` | `DISCORD_OAUTH_DENIED`                    | [discord_oauth_denied.proto](./events/discord/v1/discord_oauth_denied.proto)                         |   |
| `DiscordMaxParticipantsReachedEvent`       |  `EVENT_TYPE_TRACK` | `DISCORD_MAX_PARTICIPANTS_REACHED`        | [discord_max_participants_reached.proto](./events/discord/v1/discord_max_participants_reached.proto) |   |
