## Display Events Topology

### Events Flow chart

```mermaid
flowchart TD

    AdsDisplayRequestedEvent --> |succeeded| AdsDisplayResponseReceivedEvent{{AdsDisplayResponseReceivedEvent}}
    AdsDisplayRequestedEvent --> |failed| AdsDisplayRequestFailedEvent{{AdsDisplayRequestFailedEvent}}
    style AdsDisplayRequestedEvent fill: #577182
    style AdsDisplayResponseReceivedEvent fill: #577182
    style AdsDisplayRequestFailedEvent fill: #577182

    AdsDisplayResponseReceivedEvent -->  AdsDisplayImpressionEvent{{AdsDisplayImpressionEvent}}
    style AdsDisplayImpressionEvent fill: #82576A

    AdsDisplayImpressionEvent -->AdsDisplayViewabilityStatusEvent{{AdsDisplayViewabilityStatusEvent}}
    style AdsDisplayViewabilityStatusEvent fill: #82576A

    AdsDisplayViewabilityStatusEvent -->  AdsDisplayClickedEvent
    style AdsDisplayClickedEvent fill: #82576A

    AdsDisplayClickedEvent -->  AdsDisplayClosedEvent{{AdsDisplayClosedEvent}}
    style AdsDisplayClosedEvent fill: #826457

    AdsDisplayResponseReceivedEvent -->  AdsDisplayClickedEvent{{AdsDisplayClickedEvent}}
    AdsDisplayImpressionEvent -->  AdsDisplayClickedEvent{{AdsDisplayClickedEvent}}
    AdsDisplayImpressionEvent -->  AdsDisplayClosedEvent{{AdsDisplayClosedEvent}}
    AdsDisplayViewabilityStatusEvent -->  AdsDisplayClosedEvent{{AdsDisplayClosedEvent}}

```
NOTE: to edit charts please use [Online editor](https://mermaid.live/) and [Documentation](https://mermaid.js.org/)


### Events Details and Schemas
| Events  | [EventType](./common/v1/event_type.proto)  | [EventCode](./common/v1/event_code.proto) |  Protobuf Schema |   |
|---|---|---|---|---|
|  `AdsDisplayRequestedEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_REQUESTED`  |  [ads_display_requested.proto](./events/ads/v1/ads_display_requested.proto) |   |
|  `AdsDisplayResponseReceivedEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_RESPONSE_RECEIVED`  |  [ads_display_response_received.proto](./events/ads/v1/ads_display_response_received.proto) |   |
|  `AdsDisplayRequestFailedEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_REQUEST_FAILED`  |  [ads_display_request_failed.proto](./events/ads/v1/ads_display_request_failed.proto) |   |
|  `AdsDisplayImpressionEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_IMPRESSION`  |  [ads_display_impression.proto](./events/ads/v1/ads_display_impression.proto) |   |
|  `AdsDisplayViewabilityStatusEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_VIEWABILITY_STATUS`  |  [ads_display_viewability_status.proto](./events/ads/v1/ads_display_viewability_status.proto) |   |
|  `AdsDisplayClickedEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_CLICKED`  |  [ads_display_clicked.proto](./events/ads/v1/ads_display_clicked.proto) |   |
|  `AdsDisplayClosedEvent` |  `EVENT_TYPE_TRACK` | `ADS_PLAYBACK_STARTED`  |  [ads_display_closed.proto](./events/ads/v1/ads_display_closed.proto) |   |
|  `AdsDisplayCertifiedImpressionEvent` |  `EVENT_TYPE_TRACK` | `ADS_DISPLAY_CERTIFIED_IMPRESSION`  |  [ads_display_certified_impression.proto](./events/ads/v1/ads_display_certified_impression.proto) |   |

