## In-app updates topology

### Events Flow chart

```mermaid
flowchart TD
    UpdateAvailableEvent --> UpdateDownloadStartedEvent{{UpdateDownloadStartedEvent}}
    UpdateDownloadStartedEvent -->|succeeded| UpdateDownloadSuccessEvent{{UpdateDownloadSuccessEvent}}
    UpdateDownloadStartedEvent -->|failed| UpdateDownloadFailedEvent{{UpdateDownloadFailedEvent}}
    style UpdateAvailableEvent fill: #577182
    style UpdateDownloadStartedEvent fill: #82576A
    style UpdateDownloadSuccessEvent fill: #82576A
    style UpdateDownloadFailedEvent fill: #826457
    UpdateDownloadSuccessEvent --> UpdateInstallationStartedEvent{{UpdateInstallationStartedEvent}}
    style UpdateInstallationStartedEvent fill: #826457
```

NOTE: to edit charts please use [Online editor](https://mermaid.live/)
and [Documentation](https://mermaid.js.org/)

### Events Details and Schemas

| Events                           | [EventType](./common/v1/event_type.proto) | [EventCode](./common/v1/event_code.proto) | Protobuf Schema                                                                           |   |
|----------------------------------|-------------------------------------------|-------------------------------------------|-------------------------------------------------------------------------------------------|---|
| `UpdateAvailableEvent`           | `EVENT_TYPE_TRACK`                        | `UPDATE_AVAILABLE`                        | [update_available.proto](./events/update/v1/update_available.proto)                       |   |
| `UpdateDownloadStartedEvent`     | `EVENT_TYPE_TRACK`                        | `UPDATE_DOWNLOAD_STARTED`                 | [update_download_started.proto](./events/update/v1/update_download_started.proto)         |   |
| `UpdateDownloadFailedEvent`      | `EVENT_TYPE_TRACK`                        | `UPDATE_DOWNLOAD_FAILED`                  | [update_download_failed.proto](./events/update/v1/update_download_failed.proto)           |   |
| `UpdateDownloadSuccessEvent`     | `EVENT_TYPE_TRACK`                        | `UPDATE_DOWNLOAD_SUCCESS`                 | [update_download_success.proto](./events/update/v1/update_download_success.proto)         |   |
| `UpdateInstallationStartedEvent` | `EVENT_TYPE_TRACK`                        | `UPDATE_INSTALLATION_STARTED`             | [update_installation_started.proto](./events/update/v1/update_installation_started.proto) |   |
