
## Preroll Events Topology

### Events Flow chart

```mermaid
flowchart TD
    A[App is Launched by the User] -->|Generate SessionId| ApplicationSessionStartedEvent{{ApplicationSessionStartedEvent}}
    ApplicationSessionStartedEvent --> |User hits play button| UserPlayClickedEvent{{UserPlayClickedEvent}}
    style UserPlayClickedEvent fill: #826457

    UserPlayClickedEvent --> |evaluate eligibility / final decision| AdsVideoAudioRollEligibilityDecidedEvent{{AdsVideoAudioRollEligibilityDecidedEvent}}
    style AdsVideoAudioRollEligibilityDecidedEvent fill: #3A5A40

    AdsVideoAudioRollEligibilityDecidedEvent --> |request VideoAudioRoll| AdsVideoAudioRollRequestedEvent{{AdsVideoAudioRollRequestedEvent}}
    AdsVideoAudioRollRequestedEvent --> |succeeded| AdsVideoAudioRollResponseReceivedEvent{{AdsVideoAudioRollResponseReceivedEvent}}
    AdsVideoAudioRollRequestedEvent --> |failed| AdsVideoAudioRollRequestFailedEvent{{AdsVideoAudioRollRequestFailedEvent}}
    AdsVideoAudioRollRequestFailedEvent --> |get audio if video failed| AdsVideoAudioRollRequestedEvent{{AdsVideoAudioRollRequestedEvent}}
    style AdsVideoAudioRollRequestedEvent fill: #577182
    style AdsVideoAudioRollResponseReceivedEvent fill: #577182
    style AdsVideoAudioRollRequestFailedEvent fill: #577182

    AdsVideoAudioRollResponseReceivedEvent --> |final decision| AdsPlaybackStartedEvent{{AdsPlaybackStartedEvent}}
    AdsPlaybackStartedEvent --> |playback failed| AdsPlaybackFailedEvent{{AdsPlaybackFailedEvent}}
    AdsVideoAudioRollResponseReceivedEvent --> |unable to play| AdsPlaybackFailedEvent
    AdsPlaybackStartedEvent --> |playback finished| AdsPlaybackFinishedEvent{{AdsPlaybackFinishedEvent}}
    style AdsPlaybackStartedEvent fill: #82576A
    style AdsPlaybackFailedEvent fill: #82576A
    style AdsPlaybackFinishedEvent fill: #82576A

    AdsPlaybackFinishedEvent --> |start listening| ListenSessionStartedEvent{{ListenSessionStartedEvent}}
    AdsPlaybackFailedEvent --> |start listening| ListenSessionStartedEvent{{ListenSessionStartedEvent}}
    style ListenSessionStartedEvent fill: #826457
```



NOTE: to display charts please install [Chrome Extension](https://chrome.google.com/webstore/detail/mermaid-diagrams/)
NOTE: to edit charts please use [Online editor](https://mermaid.live/) and [Documentation](https://mermaid.js.org/)


### Events Details and Schemas
| Events  | [EventType](./common/v1/event_type.proto)  | [EventCode](./common/v1/event_code.proto) |  Protobuf Schema |   |
|---|---|---|---|---|
|  `UserPlayClickedEvent` |  `EVENT_TYPE_TRACK` | `USER_PLAY_CLICKED`  |  [user_play_clicked.proto](./events/user/v1/user_play_clicked.proto) |   |
|  `ApplicationSessionStartedEvent` |  `EVENT_TYPE_TRACK` | `APP_SESSION_STARTED`  |  [app_session_started.proto](./events/app/v1/app_session_started.proto) |   |
|  `AdsVideoAudioRollEligibilityDecidedEvent` |  `EVENT_TYPE_TRACK` | `ADS_VIDEO_AUDIO_ROLL_ELIGIBILITY_DECIDED`  |  [ads_video_audio_roll_eligibility_decided.proto](./events/ads/v1/ads_video_audio_roll_eligibility_decided.proto) |   |
|  `AdsVideoAudioRollRequestedEvent` |  `EVENT_TYPE_TRACK` | `ADS_VIDEO_AUDIO_ROLL_REQUESTED`  |  [ads_video_audio_roll_requested.proto](./events/ads/v1/ads_video_audio_roll_requested.proto) |   |
|  `AdsVideoAudioRollResponseReceivedEvent` |  `EVENT_TYPE_TRACK` | `ADS_VIDEO_AUDIO_ROLL_RESPONSE_RECEIVED`  |  [ads_video_audio_roll_response_received.proto](./events/ads/v1/ads_video_audio_roll_response_received.proto) |   |
|  `AdsVideoAudioRollRequestFailedEvent` |  `EVENT_TYPE_TRACK` | `ADS_VIDEO_AUDIO_ROLL_REQUEST_FAILED`  |  [ads_video_audio_roll_request_failed.proto](./events/ads/v1/ads_video_audio_roll_request_failed.proto) |   |
|  `AdsPlaybackStartedEvent` |  `EVENT_TYPE_TRACK` | `ADS_PLAYBACK_STARTED`  |  [ads_playback_started.proto](./events/v1/ads/ads_playback_started.proto) |   |
|  `AdsPlaybackPausedEvent` |  `EVENT_TYPE_TRACK` | `ADS_PLAYBACK_PAUSED`  |  [ads_playback_paused.proto](./events/v1/ads/ads_playback_paused.proto) |   |
|  `AdsPlaybackFinishedEvent` |  `EVENT_TYPE_TRACK` | `ADS_PLAYBACK_FINISHED`  |  [ads_playback_finished.proto](./events/ads/v1/ads_playback_finished.proto) |   |
|  `AdsPlaybackFailedEvent` |  `EVENT_TYPE_TRACK` | `ADS_PLAYBACK_FAILED`  |  [ads_playback_failed.proto](./events/ads/v1/ads_playback_failed.proto) |   |
|  `ListenSessionStartedEvent` |  `EVENT_TYPE_TRACK` | `LISTEN_SESSION_STARTED`  |  [listen_session_started.proto](./events/listen/v1/listen_session_started.proto) |   |
